VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsAutoNumber2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'***************************************************************************************************
'   ̔ԃt@CXVNX                                          clsAutoNumber2(Class)
'
'   쐬:㎡  URL:https://www.ne.jp/asahi/excel/inoue/ [Excelłd!]
'***************************************************************************************************
' ύXt Rev   ύXe---------------------------------------------------------------------->
' 22/07/20(2.0.0)VK쐬
'***************************************************************************************************
Option Explicit
'---------------------------------------------------------------------------------------------------
#If VBA7 Then
'X[v
Private Declare PtrSafe Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
#Else
'X[v
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
#End If
'---------------------------------------------------------------------------------------------------
' ݒl
Private g_blnInitialized As Boolean                                 ' ϔ
Private g_lngNumberLen As Long                                      ' ̔Ԓl
Private g_lngNumberMax As Long                                      ' ̔Ԓll
Private g_lngPrefixLen As String                                    ' vtBbNX
Private g_strPrefix As String                                       ' vtBbNX
Private g_strNumberFormat As String                                 ' ԍtH[}bg
Private g_strFilename As String                                     ' ̔ԃt@C

'***************************************************************************************************
'    ǑĂяovV[W 
'***************************************************************************************************
'* @FSetInitialValues
'* @\@@Fݒ菉lZbg
'---------------------------------------------------------------------------------------------------
'* Ԃl@Fϔ(Boolean)
'* @@FArg1 = ̔Ԓl(Long)
'* @@@@@Arg2 = vtBbNX(String)
'* @@@@@Arg3 = ̔ԃt@C(String)
'---------------------------------------------------------------------------------------------------
'* 쐬@F2022N0720
'* 쐬ҁ@F@
'* XV@F2022N0720
'* XVҁ@F@
'* @\F
'* ӎFNXɌĂяoƁANX͍ČĂяosv
'***************************************************************************************************
Friend Function SetInitialValues(ByVal lngNumberLen As Long, _
                                 ByVal strPrefix As String, _
                                 ByVal strFilename As String) As Boolean
    '-----------------------------------------------------------------------------------------------
    ' ݒ菉l̎捞
    g_lngNumberLen = lngNumberLen
    g_strPrefix = strPrefix
    g_strFilename = strFilename
    '-------------------------------------------------------
    g_lngPrefixLen = Len(g_strPrefix)
    g_strNumberFormat = String(g_lngNumberLen, "0")
    g_lngNumberMax = 10 ^ g_lngNumberLen - 1
    '-------------------------------------------------------
    ' ϔ
    g_blnInitialized = True
    SetInitialValues = True
End Function

'***************************************************************************************************
'* @FGetAutoNumber
'* @\@@FԂ̔ԍ擾
'---------------------------------------------------------------------------------------------------
'* Ԃl@F(Boolean)
'* @@FArg1 = ̔Ԓl(Long)                            RefQ
'* @@@@@Arg2 = G|bZ[W(String)                RefQ
'---------------------------------------------------------------------------------------------------
'* 쐬@F2022N0720
'* 쐬ҁ@F@
'* XV@F2022N0720
'* XVҁ@F@
'* @\F
'* ӎF
'***************************************************************************************************
Friend Function GetAutoNumber(ByRef lngNumber As Long, _
                              ByRef strErrMSG As String) As Boolean
    '-----------------------------------------------------------------------------------------------
    Dim intFF As Integer                                            ' FreeFilel
    Dim strREC As String                                            ' R[he
    Dim strNumber As String                                         ' R[he(̔Ԓl)
    Dim intCntErr As Integer                                        ' G[JE^
    Dim lngWait As Long                                             ' Wait~b
    Dim blnOpened As Boolean                                        ' t@COPEN
    
    GetAutoNumber = False
    strErrMSG = ""
    ' FreeFilel̎擾(ȍ~̒lœo͂)
    intFF = FreeFile
    On Error GoTo GetAutoNumber_OpenERROR
    ' wt@COPEN(oCi[h:rOPEN)
    Open g_strFilename For Binary Lock Read Write As #intFF
    blnOpened = True
    On Error GoTo GetAutoNumber_ERROR
    ' R[ḧ揉(lߍ)
    strREC = String(g_lngNumberLen + g_lngPrefixLen, Chr(0))
    ' R[h̎
    Get #intFF, 1, strREC
    '-------------------------------------------------------
    ' ̃t@Cf
    If g_lngPrefixLen > 0 Then
        ' vtBbNX邩
        If Left(strREC, g_lngPrefixLen) = g_strPrefix Then
            ' ̔Ԓlo^ς
            strNumber = Mid(strREC, g_lngPrefixLen + 1, g_lngNumberLen)
            lngNumber = CLng(strNumber)
            ' lłȂΑOl1
            If lngNumber >= g_lngNumberMax Then
                ' őlB́u1vɕA
                lngNumber = 1
            Else
                ' O񇂂Ɂu1v
                lngNumber = lngNumber + 1
            End If
        Else
            ' ͏lZbg
            lngNumber = 1
        End If
    ElseIf IsNumeric(strREC) Then
        ' vtBbNXȂ
        lngNumber = CLng(strREC)
        ' lłȂΑOl1
        If lngNumber >= g_lngNumberMax Then
            ' őlB́u1vɕA
            lngNumber = 1
        Else
            ' O񇂂Ɂu1v
            lngNumber = lngNumber + 1
        End If
    Else
        ' ͏lZbg
        lngNumber = 1
    End If
    '-------------------------------------------------------
    ' ߂R[hҏW(vtBbNX{̔Ԓl)
    strREC = g_strPrefix & Format(lngNumber, g_strNumberFormat)
    ' ̔ԃR[h̏o(ʒuŒu)
    Put #intFF, 1, strREC & vbCrLf
    '-------------------------------------------------------
    GetAutoNumber = True
    ' I
    GoTo GetAutoNumber_EXIT

'===============================================================================
' ̔ԃt@COPENG[
GetAutoNumber_OpenERROR:
    strErrMSG = "̔ԃt@COPENł܂B" & vbCr & _
        "  (" & Err.Description & ")"
    ' WAIT
    intCntErr = intCntErr + 1
    If intCntErr <= 10 Then
        lngWait = Int(998 * Rnd() + 1)
        Sleep lngWait
        Resume
    End If
    GoTo GetAutoNumber_EXIT

'===============================================================================
' ̔ԃt@Ĉ̑G[
GetAutoNumber_ERROR:
    ' s̏ꍇ̓G|bZ[WԂ
    strErrMSG = "̔ԃt@CREADł܂B" & vbCr & _
        "  (" & Err.Description & ")"

'===============================================================================
' I
GetAutoNumber_EXIT:
    ' wt@CCLOSE
    If blnOpened Then
        On Error Resume Next
        Close #intFF
    End If
    On Error GoTo 0
End Function

'***************************************************************************************************
'    vpeB 
'***************************************************************************************************
' ϔ
'---------------------------------------------------------------------------------------------------
Friend Property Get prpInitialized() As Boolean
    '-----------------------------------------------------------------------------------------------
    prpInitialized = g_blnInitialized
End Property

'------------------------------------------<< End of Source >>--------------------------------------
